
<!-- TITLE/ -->

# Query library for JS

<!-- /TITLE -->


<!-- BADGES/ -->

[![Build Status](https://img.shields.io/travis/pflannery/queryifyjs/master.svg)](http://travis-ci.org/pflannery/queryifyjs "Check this project's build status on TravisCI")
[![NPM version](https://img.shields.io/npm/v/queryifyjs.svg)](https://npmjs.org/package/queryifyjs "View this project on NPM")
[![NPM downloads](https://img.shields.io/npm/dm/queryifyjs.svg)](https://npmjs.org/package/queryifyjs "View this project on NPM")
[![Dependency Status](https://img.shields.io/david/pflannery/queryifyjs.svg)](https://david-dm.org/pflannery/queryifyjs)
[![Dev Dependency Status](https://img.shields.io/david/dev/pflannery/queryifyjs.svg)](https://david-dm.org/pflannery/queryifyjs#info=devDependencies)<br/>
[![Gratipay donate button](https://img.shields.io/gratipay/pflannery.svg)](https://www.gratipay.com/pflannery/ "Donate weekly to this project using Gratipay")

<!-- /BADGES -->


<!-- DESCRIPTION/ -->

A No-SQL object query library made for javascript

<!-- /DESCRIPTION -->


<!-- INSTALL/ -->

## Install

### [NPM](http://npmjs.org/)
- Use: `require('queryifyjs')`
- Install: `npm install --save queryifyjs`

### [Bower](http://bower.io/)
- Use: `require('queryifyjs')`
- Install: `bower install queryifyjs`

<!-- /INSTALL -->


## Documentation

[Library API](http://pflannery.github.io/querifyjs/)

## Usage

```js
  var models = [
    {name: 'apple'},
    {name: 'banana'},
    {name: 'pineapple'},
    {name: 'strawberry'},
    {name: 'orange'},
    {name: 'grapefruit'}
  ];
  var criteria = {
    name: /apple/,      // regexp to match any names with 'apple' in them
    $or: {              // or
      name: 'banana'  // match name against 'banana'
    }
  };
```

```js
   var results = querify.sync.filter(models, criteria);
   // produces [{"name":"apple"},{"name":"banana"},{"name":"pineapple"}]

   var criteria = {
     name: {
       $right: 'e'     // match the last char in name that contains 'e'
     }
   };

   var results = querify.sync.filter(models, criteria);
   // produces [{"name":"apple"},{"name":"pineapple"},{"name":"orange"}]
```

```js
  // direct value queries
  var result = querify.sync.filter(["myvalue", 1, 2, 3, etc], {$equals: 'myvalue'});
```

```js
   // promise based example
   var criteria = {
     name: /an/          // regexp to match any names with 'an'
   };

   querify.promise.filter(models, criteria)
     .then(function(results) {
       // produces [{"name":"banana"},{"name":"orange"}]
     });
```

<!-- BACKERS/ -->

## Backers

### Maintainers

These amazing people are maintaining this project:

- pflannery (https://github.com/pflannery)

### Sponsors

No sponsors yet! Will you be the first?

[![Gratipay donate button](https://img.shields.io/gratipay/pflannery.svg)](https://www.gratipay.com/pflannery/ "Donate weekly to this project using Gratipay")

### Contributors

These amazing people have contributed code to this project:

- [pflannery](https://github.com/pflannery) — [view contributions](https://github.com/pflannery/queryifyjs/commits?author=pflannery)

[Become a contributor!](https://github.com/pflannery/queryifyjs/blob/master/CONTRIBUTING.md#files)

<!-- /BACKERS -->


<!-- LICENSE/ -->

## License

Licensed under GNU GPL v3

Copyright &copy; 2014+ pflannery (https://github.com/pflannery)

<!-- /LICENSE -->


[![Analytics](https://ga-beacon.appspot.com/UA-47157500-1/querifyjs/readme)](https://github.com/pflannery/querifyjs)