/*
 QueryifyJs is a No-SQL object query library made for javascript
 Copyright (C) 2014 Peter Flannery

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * @module QueryifyJs
 */
/**
 * Promise based compare methods.
 *
 * @class QueryPromiseComparisons
 * @extends QueryComparisons
 */
function QueryPromiseComparisons() {
}

var queryComparisonsProto = Object.create(QueryComparisons.prototype);

queryComparisonsProto.$queryEvery = function(modelArray, criteria) {
  var scope = this;
  // iterates the promises until false or error
  return promiseExtras.every(modelArray, function(model, modelIndex, fulfil) {
    fulfil(scope.opMethods.executeQuery.call(scope, model, criteria, false));
  });
};

queryComparisonsProto.$querySome = function(modelArray, criteria) {
  var scope = this;
  // iterates the promises until finds first match, no matches or errors
  return promiseExtras.some(modelArray, function(model, modelIndex, fulfil) {
    fulfil(scope.opMethods.executeQuery.call(scope, model, criteria, false));
  });
};

QueryPromiseComparisons.prototype = queryComparisonsProto;