/*
 QueryifyJs is a No-SQL object query library made for javascript
 Copyright (C) 2014 Peter Flannery

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

function ArrayValuesIterator(arrayItems) {
  this.iteratedNextIndex = 0;
  this.iteratedObject = arrayItems;
}

ArrayValuesIterator.prototype = {
  next: function() {
    var done, value;
    done = this.iteratedNextIndex >= this.iteratedObject.length;
    if (done === false)
      value = this.iteratedObject[this.iteratedNextIndex++];

    return {
      value: value,
      done: done
    };
  }
};

ArrayValuesIterator.prototype[Symbol.iterator] = function() {
  return this;
};

function ArrayEntriesIterator(arrayItems) {
  this.iteratedNextIndex = 0;
  this.iteratedObject = arrayItems;
}

ArrayEntriesIterator.prototype = {
  superNext_: ArrayValuesIterator.prototype.next,
  next: function() {
    var value,
      index = this.iteratedNextIndex,
      nextResult = this.superNext_(),
      done = nextResult.done;

    if (done === false)
      value = [
        index,
        nextResult.value
      ];

    return {
      value: value,
      done: done
    };
  }
};

ArrayEntriesIterator.prototype[Symbol.iterator] = function() {
  return this;
};
