/*
 QueryifyJs is a No-SQL object query library made for javascript
 Copyright (C) 2014 Peter Flannery

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU Affero General Public License as
 published by the Free Software Foundation, either version 3 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var arrayProto = Array.prototype;

if (arrayProto.values === undefined) {
  arrayProto.values = function() {
    return new ArrayValuesIterator(this);
  }
}

if (arrayProto.entries === undefined) {
  arrayProto.entries = function() {
    return new ArrayEntriesIterator(this);
  }
}

if (arrayProto[Symbol.iterator] === undefined) {
  Object.defineProperty(arrayProto, Symbol.iterator, {
    value: arrayProto.values,
    configurable: true,
    enumerable: false,
    writable: true
  });
}
